# OOC

class HPS.OOC

  Public Types

  enum IOResult

    Values:

    Success
    ErrorInvalidPointCloud
    ErrorUnknownFailure
    ErrorNoOOCView
    ErrorCyclicFileDependencies
    ErrorSerializationFailure
    ErrorDeserializationFailure
    ErrorIllegalFileName
    ErrorFileSystemFailure
    ErrorOOCRootAlreadyExists
    ErrorInvalidBuffer
  class Area : public IDisposable

    Public Functions

    Area ()
    Area (HPS.OOC.Area in_that)
    Area (HPS.Rectangle in_rect, HPS.MatrixKit in_world_to_window, string in_name)
    void Dispose ()
    string GetName ()
    HPS.Point GetWindowMax ()
    HPS.Point GetWindowMin ()
    HPS.MatrixKit GetWorldToWindow ()
    bool Intersects (HPS.Point world_space_point)
    bool Intersects (HPS.SimpleCuboid world_space_bounding)
  class AreaHighlightTracker : public IDisposable

    Public Functions

    void AddArea (HPS.Rectangle in_rect, HPS.MatrixKit in_world_to_window, bool in_clear)
    void AddPoint (HPS.WorldPoint in_point, bool in_clear)
    void AddSection (HPS.Plane[] in_planes)
    void AddSection (HPS.Plane[] in_planes, bool in_clear)
    AreaHighlightTracker (HPS.Canvas in_canvas, HPS.SegmentKey in_area_cameras)
    void Clear ()
    void Dispose ()
    delegate void DtorDelegate (IntPtr cPtr)
    bool Empty ()
    HPS.SegmentKey GetAreaCameraSegment ()
    HPS.OOC.Area[] GetAreas ()
    HPS.Canvas GetCanvas ()
    bool GetInspecting ()
    HPS.WindowKey GetWindowKey ()
    bool Intersects (HPS.Point world_space_point)
    bool Intersects (HPS.SimpleCuboid world_space_bounding)
    void Process (HPS.Key[] shell_keys)
  class File

    Public Static Functions

    HPS.OOC.ImportNotifier Import (string in_file_name, HPS.OOC.ImportOptionsKit in_options)
    void Import (string in_file_name, HPS.OOC.ImportOptionsKit in_options, HPS.OOC.ImportNotifier in_notifier)
  class ImportNotifier : public HPS.IONotifier

    Public Functions

    void Assign (HPS.OOC.ImportNotifier in_that)
    override void Dispose ()
    HPS.Model GetTarget ()
    ImportNotifier ()
    ImportNotifier (HPS.IONotifier in_that)
    ImportNotifier (HPS.OOC.ImportNotifier in_that)
    override HPS.Type ObjectType ()
  class ImportOptionsKit : public HPS.Sprocket

    Public Functions

    override void Dispose ()
    override bool Empty ()
    bool Equals (HPS.OOC.ImportOptionsKit in_kit)
    override bool Equals (Object obj)
    override int GetHashCode ()
    ImportOptionsKit ()
    ImportOptionsKit (HPS.OOC.ImportOptionsKit in_kit)
    override HPS.Type ObjectType ()
    void Set (HPS.OOC.ImportOptionsKit in_kit)
    HPS.OOC.ImportOptionsKit SetAreaHighlightTracker (HPS.OOC.AreaHighlightTracker in_area_highlight_tracker)
    HPS.OOC.ImportOptionsKit SetCenterBounding (bool in_center_bounding)
    HPS.OOC.ImportOptionsKit SetManualUpdates (bool in_manual_updates)
    HPS.OOC.ImportOptionsKit SetTarget (HPS.Model in_target)
    HPS.OOC.ImportOptionsKit SetTranslation (double in_x, double in_y, double in_z)
    void Show (out HPS.OOC.ImportOptionsKit out_kit)
    bool ShowCenterBounding (out bool out_center_bounding)
    bool ShowManualUpdates (out bool out_manual_updates)
    bool ShowTarget (out HPS.Model out_model)
    bool ShowTranslation (out double out_x, out double out_y, out double out_z)
    HPS.OOC.ImportOptionsKit UnsetAreaHighlightTracker ()
    HPS.OOC.ImportOptionsKit UnsetCenterBounding ()
    HPS.OOC.ImportOptionsKit UnsetEverything ()
    HPS.OOC.ImportOptionsKit UnsetManualUpdates ()
    HPS.OOC.ImportOptionsKit UnsetTarget ()
    HPS.OOC.ImportOptionsKit UnsetTranslation ()

    Public Static Functions

    HPS.OOC.ImportOptionsKit GetDefault ()
    bool operator!= (HPS.OOC.ImportOptionsKit a, HPS.OOC.ImportOptionsKit b)
    bool operator== (HPS.OOC.ImportOptionsKit a, HPS.OOC.ImportOptionsKit b)
  class NodeHandle : public IDisposable

    Public Functions

    void Dispose ()
    bool Empty ()
    bool Equals (HPS.OOC.NodeHandle other)
    override bool Equals (Object obj)
    override int GetHashCode ()
    HPS.SegmentKey GetSegment ()
    HPS.ShellKey GetShell ()

    Public Static Functions

    bool operator!= (HPS.OOC.NodeHandle a, HPS.OOC.NodeHandle b)
    bool operator== (HPS.OOC.NodeHandle a, HPS.OOC.NodeHandle b)
  class PointCloud : public IDisposable

    Public Functions

    ulong AddPoints (HPS.Point[] points, float[] intensities, HPS.RGBColor[] color)
    HPS.OOC.IOResult CommitDeltasToFile ()
    HPS.OOC.IOResult CommitDeltasToFile (out string out_delta_file_name)
    bool DeleteFromPointCloud (HPS.OOC.AreaHighlightTracker tracker)
    void Destroy ()
    void Dispose ()
    bool Empty ()
    bool Equals (HPS.OOC.PointCloud other)
    override bool Equals (Object obj)
    void Export ()
    override int GetHashCode ()
    HPS.OOC.NodeHandle GetNodeHandle (HPS.SegmentKey node_key)
    HPS.SegmentKey GetSegment ()
    bool HasUncommittedDeltas ()
    PointCloud ()
    PointCloud (HPS.Model in_model)
    PointCloud (HPS.Model in_model, HPS.OOC.PointCloudOptions pointCloudOptions)
    bool PollUpdateNeeded ()
    HPS.OOC.QueryIterator QueryPoints (HPS.OOC.QueryFilter filter)
    void Release ()
    HPS.OOC.SynchronizedActions.Result Synchronize (HPS.OOC.Synchronized synchronized)

    Public Static Functions

    bool operator!= (HPS.OOC.PointCloud a, HPS.OOC.PointCloud b)
    bool operator== (HPS.OOC.PointCloud a, HPS.OOC.PointCloud b)
    bool ShowPointClouds (HPS.Model in_model, out HPS.OOC.PointCloud[] out_point_clouds)
  class PointCloudOptions : public IDisposable

    Public Functions

    void Dispose ()
    HPS.Point GetBoundingBoxMax ()
    HPS.Point GetBoundingBoxMin ()
    string GetOutputOOCFileName ()
    PointCloudOptions (HPS.OOC.PointCloudOptions in_that)
    PointCloudOptions (string outputOOCFilename, HPS.Point min, HPS.Point max)
  class QueryFilter : public IDisposable

    Public Functions

    bool AcceptPoint (HPS.Point point, ulong point_index)
    void Dispose ()
    delegate void DtorDelegate (IntPtr cPtr)
    QueryFilter ()
    bool RejectBounding (HPS.Point min_bound, HPS.Point max_bound)
    bool RejectNode (HPS.OOC.NodeHandle node_handle)
    bool RejectPointsInMemory ()
    bool RejectPointsOnDisk ()
  class QueryIterator : public IDisposable

    Public Types

    enum Status

      Values:

      Alive
      Dead
      ErrorUnknownFailure
      ErrorFileSystemFailure
      ErrorDeserializationFailure
      ErrorCouldNotFindNode
      ErrorCorruptNode
    enum Storage

      Values:

      Memory
      Disk

    Public Functions

    void Dispose ()
    HPS.OOC.NodeHandle GetNodeHandle ()
    HPS.Point GetNodePoint ()
    HPS.RGBColor GetNodePointColor ()
    ulong GetNodePointIndex ()
    HPS.OOC.QueryIterator.Status GetStatus ()
    HPS.OOC.QueryIterator.Storage GetStorage ()
    void Next ()
    QueryIterator ()
  class Synchronized : public IDisposable

    Public Functions

    HPS.OOC.SynchronizedActions.Result Actions (HPS.OOC.SynchronizedActions actions)
    void Dispose ()
    delegate void DtorDelegate (IntPtr cPtr)
    Synchronized ()
  class SynchronizedActions : public IDisposable

    Public Types

    enum Result

      Values:

      Success
      ErrorInvalidNode
      ErrorInvalidPointCloud
      ErrorUnknownFailure
      ErrorInternalFailure
      ErrorCouldNotFindNode
      ErrorInputIndicesAreNotStrictlyIncreasing
      ErrorIllegalInputIndices
      ErrorCorruptNode
      ErrorFileSystemFailure

    Public Functions

    HPS.OOC.SynchronizedActions.Result DeleteNode (HPS.OOC.NodeHandle node_handle)
    HPS.OOC.SynchronizedActions.Result DeleteSpecificPoints (HPS.OOC.NodeHandle node_handle, Int32[] point_indices, ulong count)
    void Dispose ()
    HPS.OOC.SynchronizedActions.Result OptimizeDeltas ()

Hello I'm HOOPSY!

HOOPSY BETA

Hello I am HOOPSY! your Docs generative AI assistant.

Ask me anything about HOOPS Visualize HPS or choose a sample question below to start a conversation:

Additional info

HOOPSY may store chats to provide and maintain the service according to OpenAI's data policy.

This feature is currently experimental. While we are continually enhancing its performance and quality, the underlying AI model may generate inaccurate or fabricated responses, especially if prompted to do so.

New Conversation
Continue generating